%MATLAB Script-file: beispiel_4_3_15_m
clf, clear

tmax = 20; t = 0:0.001:tmax;
KP = 1.0; T1 = 1.0; T2 = 4.0;
D = 0.5; om0 = 1.0;
lw = 2.0; as = -2.0;
%Allpass I. Ordnung
GA1 = tf([-KP*T1 KP],[T1 1]);

%Allpass II. Ordnung, gleiche Zeitkonstanten
GA2g = tf([KP*T1^2 -2*KP*T1 KP],[T1^2 2*T1 1]);

%Allpass II. Ordnung, verschieden Zeitkonstanten
GA2v = tf([KP*T1*T2 -KP*(T1+T2) KP],[T1*T2 (T1+T2) 1]);

%Allpass II. Ordnung, konjugiert komplexe Zeitkonstanten
GA2k = tf([KP -KP*2*D*om0 om0^2],[1  2*D*om0  om0^2]);

plot(t,step(GA1,t),'k:','LineWidth',lw)
hold on, grid on
plot(t,step(GA2g, t),'k-','LineWidth',lw)
plot(t,step(GA2v, t),'k--','LineWidth',lw)
plot(t,step(GA2k, t),'k-.','LineWidth',lw)
title ('Sprungantworten von Allpass-Elementen')
xlabel ('Zeit  t / s'), ylabel ('Sprungantwort  x _a(t)')
axis ([as  tmax -1.1 1.25])
legend(' I. Ordnung: T_1 = 1 s','II. Ordnung: T_1 = 1 s',...
       'II. Ordnung: T_1 = 1 s, T_2 = 4 s',...
       'II. Ordnung: D = 0.5, \omega_0 = 1 s^-^1')
   
plot ([0 tmax], [0  0],'k','LineWidth',1.5)
plot ([0 0], [0  -1],'k:','LineWidth',lw)
plot ([0 0], [0   1],'k-','LineWidth',lw)
plot ([0 0], [0   1],'k--','LineWidth',lw)
plot ([0 0], [0   1],'k-.','LineWidth',lw)

plot ([as 0], [0  0],'k:','LineWidth',lw)
plot ([as 0], [0  0],'k-','LineWidth',lw)
plot ([as 0], [0  0],'k--','LineWidth',lw)
plot ([as 0], [0  0],'k-.','LineWidth',lw)
