%Optimierung im Zeitbereich, Minimum-Berechnung
%optimierung_ISTAE_var_om0_n.m
%Variation von om = omk
%Zeitgewichtete Betragsregelflche ISTAE
% zum Plotten delta_t = 0.001, sonst delta_t = 0.00001
clf, clear, clc, format long

n_ges = 8;
delta_t = 0.00001; tmax = 12.0; nn = round (tmax / delta_t);
x = zeros (nn+1,1); t = zeros (nn+1,1); t = 0:delta_t:tmax;
A_ISTAE = zeros(n_ges,1); om_vektor = ones (n_ges, 9);
ue = zeros (n_ges,1); ue(1) = 0.0; tanr = zeros(n_ges,1); tanr(1) = inf;
den_ISTAE = zeros (n_ges, 9); den_ISTAE(1,:) = [0 0 0 0 0 0 0 1 1];

%Ergebnisse
A_ISTAE(2) = 4.331462509982747;
ue(2) = 0.012283056789833; tanr(2) = 4.3390;
f1m = 1.62763;
den_ISTAE(2,:) = [0 0 0 0 0 0 1 f1m 1];

%Ergebnisse
A_ISTAE(3) = 7.782373123476257;
ue(3) = 0.009008562312750; tanr(3) = 4.6965;
f1m =   2.26958; f2m =   2.01906;
den_ISTAE(3,:) = [0 0 0 0 0 1 f2m f1m 1];

%Ergebnisse
A_ISTAE(4) =  12.710022684075627;
ue(4) = 0.009677289485803; tanr(4) = 5.1578;
f1m =  2.80712; f2m =  3.56730; f3m =  2.27458;
den_ISTAE(4,:) = [0 0 0 0 1 f3m f2m f1m 1];

%Ergebnisse
A_ISTAE(5) =  19.433547551200569;
ue(5) = 0.010940740280230; tanr(5) = 5.6595;
f1m =  3.38689; f2m =  5.14257; f3m =  4.83462; f4m =  2.45165;
den_ISTAE(5,:) = [0 0 0 1 f4m f3m f2m f1m 1];

%Ergebnisse
A_ISTAE(6) =  28.264889697670700;
ue(6) = 0.012511276267243; tanr(6) = 6.1799;
f1m =  3.90980; f2m =  7.22620;  f3m =  7.82082;
f4m =  6.06548; f5m =  2.58212;
den_ISTAE(6,:) = [0 0 1 f5m f4m f3m f2m f1m 1];


%Ergebnisse
A_ISTAE(7) = 39.513226132180236; 
ue(7) = 0.014324041942489; tanr(7) = 6.7076;
f1m =  4.46834; f2m =  9.35712; f3m = 12.48111;
f4m = 10.72762; f5m =  7.26379; f6m =  2.68199; 
den_ISTAE(7,:) = [0 1 f6m f5m f4m f3m f2m f1m 1];

%Ergebnisse
A_ISTAE(8) =  53.483594813948045;
ue(8) =  0.016264273386865; tanr(8) = 7.2400;
f1m =  4.98804; f2m = 11.97780; f3m = 17.75384;
f4m = 19.09813; f5m = 13.79664; f6m = 8.43736;
f7m = 2.76179;
den_ISTAE(8,:) = [1 f7m f6m f5m f4m f3m f2m f1m 1];

for n = 2:n_ges
    ttt = 0.0; om_max = 10;
for om = 1:om_max 
    om_vektor = ones (n_ges,9); den = zeros (n_ges,9);
    for j1 = 1:n_ges
        for j2 = 1:j1    
        om_vektor(j1,10-j2) = om_vektor(j1,10-j2).* om^(j1-j2+1);
        end
    end
    den = den_ISTAE .* om_vektor;
    x = step (tf(om^n, den(n,:)), t);
    ue = max(x) - 1.0; 
    k = 1;
    while x(k) < 1.0 && t(k) < tmax
       k = k + 1;
    end
    tanr = t(k); ue; tanr_m_om = tanr * om;
    %plot(t, x), hold on, grid on,
    ttt = ttt + tanr * om;
end
n, tanr_m_om = ttt / om_max,
end

title ('Optimierung im Zeitbereich, ISTAE-Kriterium')
xlabel('Normierte Zeit \omega_k* t')
ylabel('Sprungantwort x(t)')
axis([0 tmax 0 1.10])

%Ergebnisse ISTAE, fr om = 1:10, n = 2:8, delta_t = 0.00001
%n = 2, tanr_m_om = 4.3390
%n = 3, tanr_m_om = 4.6965
%n = 4, tanr_m_om = 5.1578
%n = 5, tanr_m_om = 5.6595
%n = 6, tanr_m_om = 6.1799
%n = 7, tanr_m_om = 6.7076
%n = 8, tanr_m_om = 7.2400
