%Optimierung im Zeitbereich, Minimum-Berechnung
%Zeitgewichtete Betragsregelflche ITAE
%optimierung_ITAE_ramp.m
%Eingangsgre Rampenfunktion
clear, clf, clc, format long

delta_t = 0.0001; tmax = 250.0; nn = round (tmax / delta_t);
x = zeros (nn+1,1); t = 0:delta_t:tmax; w = t';
dfa = 1.0e-4; df_min = 0.75e-4; nmax = 8;

berechne = 1; n = 2; %Ergebnisse
A_ITAE = 1.796923992664824; f1m = 1.6847;
%Minimum-Berechnung
A_min = inf; df =  dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0; 
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df   
    G_ITAE_r(n) = tf([f1 1], [1 f1 1]);
    x = lsim(G_ITAE_r(n), w, t);
    A = delta_t * trapz(t' .* abs(w - x));
    A = A - delta_t * t(end) * abs(w(end)-x(end))/2.0;
    if A_min > A + eps
       A_min = A; f1_min = f1; anz_min = anz_min + 1;
    end
end
j = j + 1, df, anz_min, A_ITAE = A_min, f1m = f1_min
end
df = df / 2.0;
end
G_ITAE_r(n) = tf([f1m 1], [1 f1m 1]);

berechne = 0; n = 3; %Ergebnisse
A_ITAE = 3.082469811036809; f1m = 2.7648; f2m = 1.3915;
%Minimum-Berechnung
A_min = inf; df =  dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df 
    for f2 = f2m-df:df:f2m+df 
        G_ITAE_r(n) = tf([f1 1], [1 f2 f1 1]); x = lsim(G_ITAE_r(n), w, t);
        A = delta_t * trapz(t' .* abs(w - x));
        A = A - delta_t * t(end) * abs(w(end)-x(end))/2.0;
        if A_min > A + eps
           A_min = A; anz_min = anz_min + 1; f1_min = f1; f2_min = f2;
        end
    end
end
j = j + 1, df, anz_min, A_ITAE = A_min, f1m = f1_min, f2m = f2_min,
end
df = df / 2.0;
end
G_ITAE_r(n) = tf([f1m 1], [1 f2m f1m 1]);

berechne = 0; n = 4; %Ergebnisse
A_ITAE = 8.136447159041639; f1m = 2.6274; f2m = 3.3730; f3m = 2.0059;
%Minimum-Berechnung
A_min = inf; df = dfa; 
while df > df_min && berechne == 1
anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df 
    for f2 = f2m-df:df:f2m+df 
        for f3 = f3m-df:df:f3m+df
            G_ITAE_r(n) = tf ([f1 1], [1 f3 f2 f1 1]);
            x = lsim(G_ITAE_r(n), w, t);
            A = delta_t * trapz(t' .* abs(w - x));
            if A_min > A + eps
               A_min = A; anz_min = anz_min + 1; 
               f1_min = f1; f2_min = f2; f3_min = f3;
            end
        end
    end
end
j = j + 1, df, anz_min, A_ITAE = A_min, 
f1m = f1_min, f2m = f2_min, f3m = f3_min 
end
df = df / 2.0;
end
G_ITAE_r(n) = tf ([f1m 1], [1 f3m f2m f1m 1]);

berechne = 0; n = 5; %Ergebnisse
A_ITAE = 12.222594396499623;
f1m = 3.6211; f2m = 4.5330; f3m = 4.7225; f4m = 1.7627; 
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
    for f2 = f2m-df:df:f2m+df
        for f3 = f3m-df:df:f3m+df
            for f4 = f4m-df:df:f4m+df           
                G_ITAE_r(n) = tf ([f1 1], [1 f4 f3 f2 f1 1]);
                x = lsim(G_ITAE_r(n), w, t);
                A = delta_t * trapz(t' .* abs(w - x));
                if A_min > A
                   A_min = A; anz_min = anz_min + 1;
                   f1_min = f1; f2_min = f2; f3_min = f3; f4_min = f4;
                end
            end
        end
    end
end
j = j + 1, df, anz_min, A_ITAE = A_min,
f1m = f1_min, f2m = f2_min, f3m = f3_min, f4m = f4_min
end
df = df / 2.0;
end
G_ITAE_r(n) = tf ([f1m 1], [1 f4m f3m f2m f1m 1]);

berechne = 0; n = 6; %Ergebnisse
A_ITAE = 20.920631163091585;
f1m = 3.6631; f2m = 6.7873; f3m = 6.8777; f4m = 5.6405; f5m = 2.1625;
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
    for f2 = f2m-df:df:f2m+df
        for f3 = f3m-df:df:f3m+df
            for f4 = f4m-df:df:f4m+df           
                for f5 = f5m-df:df:f5m+df
                    G_ITAE_r(n) = tf ([f1 1], [1 f5 f4 f3 f2 f1 1]);
                    x = lsim(G_ITAE_r(n), w, t);
                    A = delta_t * trapz(t' .* abs(w - x));
                    if A_min > A + eps
                    A_min = A; anz_min = anz_min + 1; 
                    f1_min = f1; f2_min = f2; f3_min = f3; f4_min = f4;
                    f5_min = f5;
                    end
                end
            end
        end
    end
end
j = j + 1, df, anz_min, A_ITAE = A_min, 
f1m = f1_min, f2m = f2_min, f3m = f3_min, f4m = f4_min, f5m = f5_min, 
end
df = df / 2.0;
end
G_ITAE_r(n) = tf ([f1m 1], [1 f5m f4m f3m f2m f1m 1]);

berechne = 0; n = 7; %Ergebnisse
A_ITAE =  29.274771441496881;
f1m =  4.5711; f2m =  8.6880; f3m = 12.0308;
f4m =  8.9105; f5m =  6.8529; f6m =  1.9827;
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
    f1
    for f2 = f2m-df:df:f2m+df 
        for f3 = f3m-df:df:f3m+df 
            for f4 = f4m-df:df:f4m+df            
                for f5 = f5m-df:df:f5m+df 
                    for f6 = f6m-df:df:f6m+df
                    G_ITAE_r(n) = tf ([f1 1], [1 f6 f5 f4 f3 f2 f1 1]);
                    x = lsim(G_ITAE_r(n), w, t);
                    A = delta_t * trapz(t' .* abs(w - x));
                    if A_min > A + eps
                    A_min = A; anz_min = anz_min + 1; 
                    f1_min = f1; f2_min = f2; f3_min = f3;
                    f4_min = f4; f5_min = f5; f6_min = f6;
                    end
                    end
                end
            end
        end
    end
end
j = j + 1, df, anz_min, A_ITAE = A_min,
f1m = f1_min, f2m = f2_min, f3m = f3_min
f4m = f4_min, f5m = f5_min, f6m = f6_min 
end
df = df / 2.0;
end
G_ITAE_r(n) = tf ([f1m 1], [1 f6m f5m f4m f3m f2m f1m 1]);

berechne = 0; n = 8; %Ergebnisse
A_ITAE =  42.708541231387045;
f1m =  4.7401; f2m = 11.3288; f3m = 15.9532;
f4m = 17.6084; f5m = 11.8231; f6m =  7.8628; f7m =  2.2745;
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
    f1
    for f2 = f2m-df:df:f2m+df 
        for f3 = f3m-df:df:f3m+df 
            for f4 = f4m-df:df:f4m+df            
                for f5 = f5m-df:df:f5m+df 
                    for f6 = f6m-df:df:f6m+df
                    for f7 = f7m-df:df:f7m+df
                    G_ITAE_r(n) = tf ([f1 1], [1 f7 f6 f5 f4 f3 f2 f1 1]);
                    x = lsim(G_ITAE_r(n), w, t);
                    A = delta_t * trapz(t' .* abs(w - x));
                    if A_min > A + eps
                    A_min = A; anz_min = anz_min + 1; 
                    f1_min = f1; f2_min = f2; f3_min = f3; f4_min = f4;
                    f5_min = f5; f6_min = f6; f7_min = f7;
                    end
                    end
                    end
                end
            end
        end
    end
end
j = j + 1, df, anz_min, A_ITAE = A_min,
f1m = f1_min, f2m = f2_min, f3m = f3_min
f4m = f4_min, f5m = f5_min, f6m = f6_min, f7m = f7_min 
end
df = df / 2.0;
end
G_ITAE_r(n) = tf ([f1m 1], [1 f7m f6m f5m f4m f3m f2m f1m 1]);

t = 0:10.0*delta_t:8; w = t';
subplot(121)
hold off
for n = 2:nmax
        x = lsim(G_ITAE_r(n), w, t);
        plot(t, x), hold on, grid on
end
plot(t, w, 'k:')
axis ([0 8 -0.25 8.25])
title('ITAE-Optimierung des')
xlabel('Zeit t / s'), ylabel('Anstiegsantwort x(t)')

subplot (122)
hold off
for n = 2:nmax
        x = lsim(G_ITAE_r(n), w, t);
        plot(t, (w - x)), hold on, grid on
end
axis ([0 8 -0.1 3.075])
title('Geschwindigkeitsfehlers fr w(t) = t, \omega_k = 1 s^-^1')
xlabel('Zeit t / s'), ylabel('Regeldifferenz e(t) = w(t) - x(t)')

