%Optimierung im Zeitbereich, Minimum-Berechnung
%optimierung_ITAE_var_om0_n.m
%Variation von om = omk
% zum Plotten delta_t = 0.001, sonst delta_t = 0.00001
%Zeitgewichtete Betragsregelflche ITAE

clf, clear, clc, %format long

n_ges = 8;
delta_t = 0.001; tmax = 12.0; nn = round (tmax / delta_t);
x = zeros (nn+1,1); t = zeros (nn+1,1); t = 0:delta_t:tmax;
A_ITAE = zeros(n_ges,1); om_vektor = ones (n_ges, 9);
ue = zeros (n_ges,1); ue(1) = 0.0; tanr = zeros(n_ges,1); tanr(1) = inf;
den_ITAE = zeros (n_ges, 9); den_ITAE(1,:) = [0 0 0 0 0 0 0 1 1];

%Ergebnisse
A_ITAE(2) = 1.951859463587026;
ue(2) = 0.027629030805040; tanr(2) = 3.6781;
f1m = 1.50488;
den_ITAE(2,:) = [0 0 0 0 0 0 1 f1m 1];
den = den_ITAE(2,:) .* om_vektor (2);

%Ergebnisse
A_ITAE(3) = 3.138258640798573;
ue(3) = 0.015706252695714; tanr(3) = 4.1460;
f1m = 2.17148; f2m = 1.78277;
den_ITAE(3,:) = [0 0 0 0 0 1 f2m f1m 1];

%Ergebnisse
A_ITAE(4) = 4.591274872572390;
ue(4) = 0.018460663751421; tanr(4) = 4.6661;
f1m = 2.64731; f2m = 3.34577; f3m = 1.95205;
den_ITAE(4,:) = [0 0 0 0 1 f3m f2m f1m 1];

%Ergebnisse
A_ITAE(5) = 6.321555390740167;
ue(5) = 0.017212887253645; tanr(5) = 5.2051;
f1m =  3.25683; f2m = 4.67312; f3m = 4.49761; f4m = 2.06681;
den_ITAE(5,:) = [0 0 0 1 f4m f3m f2m f1m 1];

%Ergebnisse
A_ITAE(6) = 8.333970580795551;
ue(6) = 0.019299578791544; tanr(6) = 5.7504;
f1m = 3.73991; f2m = 6.79289; f3m = 6.93466;
f4m = 5.62939; f5m = 2.15236;
den_ITAE(6,:) = [0 0 1 f5m f4m f3m f2m f1m 1];

%Ergebnisse
A_ITAE(7) = 10.630574278460402;
ue(7) = 0.021727978224560; tanr(7) = 6.297;
f1m =  4.32321; f2m =  8.68119; f3m = 11.58146;
f4m =  9.35470; f5m =  6.74615; f6m =  2.21975;
den_ITAE(7,:) = [0 1 f6m f5m f4m f3m f2m f1m 1];

%Ergebnisse
A_ITAE(8) =  13.211345801118416;
ue(8) = 0.024324272574587; tanr(8) = 6.8427;
f1m =  4.81455; f2m = 11.33922; f3m = 16.11398;
f4m = 17.59247; f5m = 11.88819; f6m =  7.85196;
f7m =  2.27509;
den_ITAE(8,:) = [1 f7m f6m f5m f4m f3m f2m f1m 1];

for n = 2:n_ges
    ttt = 0.0; om_max = 10.0;
for om = 1:1%om_max 
    om_vektor = ones (n_ges,9); den = zeros (n_ges,9);
    for j1 = 1:n_ges
        for j2 = 1:j1    
        om_vektor(j1,10-j2) = om_vektor(j1,10-j2).* om^(j1-j2+1);
        end
    end
    den = den_ITAE .* om_vektor;
    x = step (tf(om^n, den(n,:)), t);
    ue = max(x) - 1.0; 
    k = 1;
    while x(k) < 1.0 && t(k) < tmax
       k = k + 1;
    end
    tanr = t(k); ue; tanr_m_om = tanr * om;
    plot(t, x), hold on, grid on,
    ttt = ttt + tanr * om;
end
n, tanr_m_om = ttt/10,
end

title ('Optimierung im Zeitbereich, ITAE-Kriterium')
xlabel('Normierte Zeit \omega_k* t')
ylabel('Sprungantwort x(t)')
axis([0 tmax 0 1.10])

%Ergebnisse ITAE, fr om = 1:10, n = 2:8, delta_t = 0.00001
%n =    2, tanr_m_om =   3.6780
%n =    3, tanr_m_om =   4.1460
%n =    4, tanr_m_om =   4.6661
%n =    5, tanr_m_om =   5.2050
%n =    6, tanr_m_om =   5.7504
%n =    7, tanr_m_om =   6.2970
%n =    8, tanr_m_om =   6.8427
